
class Boat:
    CAPACITY = 150.0  # 150L of fuel
    FUEL_CONSUMPTION = 20.0  # 20L/hour
    DOLLARS_PER_LITRE = 1.69  # $1.69/L of fuel
    SPEED = 20.0  # averages 20.0km/hour

    def __init__(self):
        self.fuel = self.CAPACITY
        self.totalDistance = 0.0

    def BoatAddFuel(self, amount):
        self.fuel += amount
        if self.fuel > self.CAPACITY:
            print("Fuel overflow, capping at " + str(self.CAPACITY) + "L.")
            self.fuel = self.CAPACITY

    def GetBoatDistance(self):
        # Calculate boat distance logic
        return self.totalDistance

    def GetBoatTime(self):
        time = self.totalDistance / self.SPEED
        return time

    def GetBoatFuelLevel(self):
        # Calculate boat fuel consumption logic
        return self.fuel

    def GetBoatFuelCost(self):
        cost = self.FUEL_CONSUMPTION * self.GetBoatTime() * self.DOLLARS_PER_LITRE
        return cost

    def BoatTravel(self, distance):
        time = distance / self.SPEED
        maxTime = self.fuel / self.FUEL_CONSUMPTION
        if maxTime < time:
            maxDistance = maxTime * self.SPEED
            print("Not enough fuel to travel " + str(distance) + "km. Travelling " + str(maxDistance) + "km instead.")
            self.totalDistance += maxDistance
            self.fuel = 0.0
        else:
            self.totalDistance += distance
            self.fuel -= time * self.FUEL_CONSUMPTION
